addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if player.anglestand
				if not (player.cmd.forwardmove and player.cmd.sidemove)
				and P_IsPlayerOnGround(player)
				and (player.panim & PA_IDLE)
				and player.truedrawangle ~= nil
				and P_IsPlayerManiafied(player)
					player.drawangle = player.truedrawangle
				end
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if not P_IsPlayerManiafied(player) return end
		if player.momentum
			if (player.speed >= skins[player.mo.skin].runspeed
			or player.powers[pw_underwater])
			and (player.cmd.forwardmove or player.cmd.sidemove)
				player.mo.friction = FRACUNIT
				player.charflags = $ & ~SF_NOSKID
			else
				player.mo.friction = 29*FRACUNIT/32
				player.charflags = $ & ~SF_NOSKID
			end
		end
		if player.truedrawangle == nil
			player.truedrawangle = player.drawangle
		end
		if player.cmd.forwardmove 
		or player.cmd.sidemove
			player.truedrawangle = player.drawangle
		end
		if not P_IsPlayerOnGround(player)
			player.truedrawangle = player.drawangle
		end
		if player.panim ~= PA_IDLE
			player.truedrawangle = player.drawangle
		end
		if player.sprung == nil
			player.sprung = false
		end
		if P_IsPlayerOnGround(player)
		and not (player.mo.eflags & MFE_SPRUNG)
			player.sprung = false
		elseif (player.mo.eflags & MFE_SPRUNG)
		and not P_IsPlayerOnGround(player)
			player.sprung = true
		end
		if player.sprung
		and player.panim ~= PA_SPRING
			player.sprung = false
		end
		if player.airwalk
			if player.mo.momz == 0
			and player.sprung
				player.mo.state = S_PLAY_WALK
			end
		end
		if player.fallback
			if player.speed >= skins[player.mo.skin].runspeed*3
				player.camerascale = $ + FRACUNIT/100
			elseif player.speed < skins[player.mo.skin].runspeed*3
			and player.camerascale > FRACUNIT
				player.camerascale = $ - FRACUNIT/15
			end
		else
			player.camerascale = FRACUNIT
		end
		if player.prevspringx == nil
			player.prevspringx = player.mo.x
		end
		if player.prevspringy == nil
			player.prevspringy = player.mo.y
		end
		if not (player.mo.eflags & MFE_SPRUNG)
			player.prevspringx = player.mo.x
			player.prevspringy = player.mo.y
		end
		if player.shoes
			if player.powers[pw_sneakers]
			and leveltime%2 == 0
				M_SpawnGhost(player)
			end
		end
		if player.prevz == nil
			player.prevz = player.mo.z
		end
		if leveltime%2 == 0
			player.prevz = player.mo.z
		end
		if player.classic
			if player.mo.standingslope
			and player.mo.z < player.prevz
			and (player.cmd.forwardmove or player.cmd.sidemove)
				if (player.pflags & PF_SPINNING)
					P_Thrust(player.mo, player.drawangle, 5*FRACUNIT/2)
				else
					P_Thrust(player.mo, player.drawangle, FRACUNIT)
				end
			end
			if player.mo.standingslope
			and player.mo.z > player.prevz
				if player.speed >= player.normalspeed
					if (player.pflags & PF_SPINNING)
						P_Thrust(player.mo, player.drawangle, -1*FRACUNIT)
					else
						P_Thrust(player.mo, player.drawangle, -1*FRACUNIT/4)
					end
				else
					if (player.pflags & PF_SPINNING)
						P_Thrust(player.mo, player.drawangle, -1*FRACUNIT/4)
					else
						P_Thrust(player.mo, player.drawangle, -1*FRACUNIT/8)
					end
				end
			end
		end
		if player.solidspring == nil
			player.solidspring = false
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.cd continue end
			if player.redrawangle == nil
				player.redrawangle = player.mo.angle
			end
			if player.shouldrotate == nil
				player.shouldrotate = false
			end
			if player.springtype == nil
				player.springtype = "none"
			end
			if (player.mo.eflags & MFE_SPRUNG)
				player.sprung = true
			end
			if player.sprung
			and player.shouldrotate
			and player.springtype == "verti"
			and player.mo.momz > 0*FRACUNIT
				player.drawangle = player.redrawangle
				player.redrawangle = $ + FixedAngle(21*FRACUNIT)
			end
			if not player.sprung
				player.shouldrotate = false
				player.springtype = "none"
			end
		end
	end
end)

addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.valid
		if P_IsPlayerManiafied(player)
			player.truedrawangle = player.drawangle
		end
	end
end)

addHook("MobjCollide", function(touched, toucher)
	if touched and touched.valid
	and toucher and toucher.valid
	and toucher.player and toucher.player.valid
	and M_SpringType(touched) == "verti"
		local player = toucher.player
		player.shouldrotate = true
		player.springtype = "verti"
	end
	if touched and touched.valid
	and toucher and toucher.valid
	and toucher.player and toucher.player.valid
	and M_SpringType(touched) == "verti"
		local player = toucher.player
		if not P_IsPlayerManiafied(player) return end
		if not toucher.player.solidspring
			if not player.sp return end
			if toucher.z - toucher.momz > (touched.height/2) + touched.z then return end
			if touched.z > toucher.height + toucher.z - toucher.momz then return end
			player.solidspring = true
			P_SetOrigin(toucher, player.prevspringx, player.prevspringy, player.mo.z)
			player.powers[pw_pushing] = $ + 1
			if P_IsObjectOnGround(player.mo)
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
				player.mo.momx = 0
				player.mo.momy = 0
			end
			player.solidspring = false
			return true
		end
	end
end)

addHook("PreThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.classic continue end
			if (player.pflags & PF_SPINNING)
			and not P_IsPlayerOnGround(player)
				player.pflags = $ & ~PF_SPINNING
			end
			if player.jumptics == 1
			and (player.pflags & PF_SPINNING)
			and not player.mo.standingslope
				if player.speed > skins[player.mo.skin].normalspeed
					if player.speed >= skins[player.mo.skin].normalspeed/2
						P_Thrust(player.mo, player.drawangle, (skins[player.mo.skin].normalspeed - skins[player.mo.skin].normalspeed*2)/5)
					end
				end
			end
			if player.jumptics == 1
			and player.mo.standingslope
				if player.mo.z < player.prevz
					if (player.pflags & PF_SPINNING)
						P_InstaThrust(player.mo, player.drawangle, (player.speed + 10*FRACUNIT))
					else
						P_InstaThrust(player.mo, player.drawangle, (player.speed + 5*FRACUNIT))
					end
				end
			end
			if ((player.cmd.buttons & BT_USE) or player.dropdash)
			and (player.mo.eflags & MFE_JUSTHITFLOOR)
			and player.mo.standingslope
				if (player.cmd.buttons & BT_USE)
					P_Thrust(player.mo, player.drawangle, (AngleFixed(player.mo.standingslope.zangle))/20)
				else
					P_Thrust(player.mo, player.drawangle, (AngleFixed(player.mo.standingslope.zangle))/4)
				end
			end
		end
	end
end)

addHook("SpinSpecial", function(player)
	if not P_IsPlayerManiafied(player) return end
	if not player.crouching return end
	if (P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_JUSTHITFLOOR) or player.rollout and (player.powers[pw_carry] & CR_ROLLOUT))
	and player.mo.momz == 0
	and player.speed < 9*FRACUNIT
	and (player.charability2 & CA2_SPINDASH)
	and not player.sprung
		player.crouch = true
		player.pflags = $|PF_FULLSTASIS
		return true
	end
end)

addHook("PreThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.crouching continue end
			if (P_IsPlayerOnGround(player) or player.rollout and player.crouching)
			and player.crouch
			and player.jumptics == 1
				player.fakespin = true
				player.crouch = false
				S_StartSound(player.mo, sfx_spndsh)
				player.mo.state = S_PLAY_SPINDASH
				player.fakespincharge = 20*FRACUNIT
			elseif player.fakespin == true
			and (P_IsPlayerOnGround(player) or player.rollout and player.crouching)
			and player.jumptics == 1
				player.fakespincharge = $ + 10*FRACUNIT
				S_StartSound(player.mo, sfx_spndsh)
				player.mo.state = S_PLAY_SPINDASH
			end
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.peelout continue end
			if player.peelouting == nil
				player.peelouting = false
			end
			if player.peeloutstrength == nil
				player.peeloutstrength = 0
			end
			if (player.cmd.buttons & BT_CUSTOM1)
			and P_IsPlayerOnGround(player)
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
			and not player.crouch
			and not player.fakespin
			and not (player.pflags & PF_FULLSTASIS)
			and not (player.pflags & PF_STASIS)
			and player.speed < 9*FRACUNIT
				if not player.peelouting
					S_StartSound(player.mo, sfx_spndsh)
				end
				player.peelouting = true
				if not player.powers[pw_sneakers]
					if not player.powers[pw_super]
						player.peeloutstrength = $ + FRACUNIT
					else
						player.peeloutstrength = $ + 2*FRACUNIT
					end
				else
					if not player.powers[pw_super]
						player.peeloutstrength = $ + 2*FRACUNIT
					else
						player.peeloutstrength = $ + 4*FRACUNIT
					end
				end
			end
			if not (player.cmd.buttons & BT_CUSTOM1)
			and player.peelouting
			and not (player.crouch or player.fakespin)
				if not player.powers[pw_sneakers]
					if not player.powers[pw_underwater]
						if not player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						else
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength*2)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						end
					else
						if not player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength/2)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						else
							P_InstaThrust(player.mo, player.mo.angle, (player.peeloutstrength))
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						end
					end
				else
					if not player.powers[pw_underwater]
						if not player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength*2)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						else
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength*4)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						end
					else
						if not player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						else
							P_InstaThrust(player.mo, player.mo.angle, player.peeloutstrength*2)
							if player.mo.state == S_PLAY_PEELOUT_WALK
								player.mo.state = S_PLAY_WALK
							elseif player.mo.state == S_PLAY_PEELOUT_RUN
								player.mo.state = S_PLAY_RUN
							end
						end
					end
				end
				player.peelouting = false
				player.pflags = $ & ~PF_JUMPSTASIS
				S_StartSound(player.mo, sfx_zoom)
				player.peeloutstrength = 0
			end
			if ((P_PlayerInPain(player)
			or player.powers[pw_carry]
			or player.crouch
			or player.fakespin
			or (player.pflags & PF_FULLSTASIS)
			or (player.pflags & PF_STASIS)))
			and player.peelouting
				player.peelouting = false
				player.pflags = $ & ~PF_JUMPSTASIS
				player.peeloutstrength = 0
			end
			if player.peelouting
				player.mo.momx = 0
				player.mo.momy = 0
				player.pflags = $|PF_FULLSTASIS
				player.drawangle = player.mo.angle
				coollookindust(player)
				if player.peeloutstrength < skins[player.mo.skin].runspeed
					player.mo.state = S_PLAY_PEELOUT_WALK
				elseif player.peeloutstrength >= skins[player.mo.skin].runspeed
				and player.peeloutstrength < 60*FRACUNIT
					player.mo.state = S_PLAY_PEELOUT_RUN
				elseif player.peeloutstrength >= 60*FRACUNIT
				and player.peeloutanim
					player.mo.state = S_PLAY_DASH
				elseif player.peeloutstrength >= 60*FRACUNIT
				and not player.peeloutanim
					player.mo.state = S_PLAY_PEELOUT_RUN
				end
				if player.peeloutstrength > 70*FRACUNIT
					player.peeloutstrength = 70*FRACUNIT
				end
			end
		end
	end
end)

//Insta Shield

addHook("PlayerThink", function(player)
	if player.instashield == nil
		player.instashield = 0
	end
	if player.instashield > 0
		player.instashield = $ - 1
	end
end)

addHook("AbilitySpecial", function(player)
	if not P_IsPlayerManiafied(player) return end
	if not player.insta return end
	if player.instas return end
	if player.mo and player.mo.valid
	and (player.cmd.buttons & BT_JUMP)
	and not P_IsPlayerOnGround(player)
	and not (player.pflags & PF_THOKKED)
	and (player.pflags & PF_JUMPED)
	and not player.powers[pw_super]
	and not (player.powers[pw_shield] & SH_NOSTACK)
		local instashield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_INSTASHIELD)
		instashield.radius = player.mo.radius*2
		instashield.height = player.mo.height*2
		instashield.scale = player.mo.scale*3/2
		instashield.target = player.mo
		player.pflags = $|PF_THOKKED
		S_StartSound(player.mo, sfx_s3k42)
		player.powers[pw_flashing] = 8
		player.instashield = 8
		return false
	end
end)

addHook("SpinSpecial", function(player)
	if not P_IsPlayerManiafied(player) return end
	if not player.insta return end
	if not player.instas return end
	if player.mo and player.mo.valid
	and (player.cmd.buttons & BT_USE)
	and not P_IsPlayerOnGround(player)
	and not (player.pflags & PF_THOKKED)
	and (player.pflags & PF_JUMPED)
	and not player.powers[pw_super]
	and not (player.powers[pw_shield] & SH_NOSTACK)
		local instashield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_INSTASHIELD)
		instashield.radius = player.mo.radius*2
		instashield.height = player.mo.height*2
		instashield.scale = player.mo.scale*3/2
		instashield.target = player.mo
		player.pflags = $|PF_THOKKED
		S_StartSound(player.mo, sfx_s3k42)
		player.powers[pw_flashing] = 8
		player.instashield = 8
		return false
	end
end)

addHook("MobjThinker", function(mobj)
	if mobj and mobj.valid
	and mobj.target and mobj.target.valid
		local player = mobj.target.player
		P_SetOrigin(mobj, player.mo.x, player.mo.y, player.mo.z)
		mobj.angle = player.drawangle
	end
end, MT_INSTASHIELD)

addHook("MobjCollide", function(touched, toucher)
	if touched and touched.valid
	and toucher and toucher.valid
	and toucher.target and toucher.target.valid
	and toucher.target.player
		local player = toucher.target
		P_DamageMobj(touched, toucher, toucher.target, 1)
		if player.instar
			player.mo.momx = -$
			player.mo.momy = -$
			player.mo.momz = -$
		end
	end
end, MT_INSTASHIELD)

addHook("ShouldDamage", function(target, inflictor)
	if target and target.valid
	and inflictor and inflictor.valid
	and target.player and target.player.valid
	and (inflictor.flags & MF_MISSILE)
	and target.player.instashield
		local player = target.player
		inflictor.momx = -$
		inflictor.momy = -$
		inflictor.momz = -$
		inflictor.target = target
		return false
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.rollafteruse continue end
			if (player.pflags & PF_THOKKED)
			and player.mo.momz < -5*FRACUNIT
			and player.candropdash
				player.mo.state = S_PLAY_FALL
			end
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if player.timeout ~= true continue end
			if player.realtime/TICRATE >= 600
			and player.playerstate == PST_LIVE
				P_KillMobj(player.mo)
			end
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if player.cdtimeout ~= true continue end
			if player.cdtimeouttimer == nil
				player.cdtimeouttimer = 0
			end
			if player.speed == 0*FRACUNIT
			and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
			and P_IsPlayerOnGround(player)
				player.cdtimeouttimer = $ + 1
			else
				player.cdtimeouttimer = 0
			end
			if player.cdtimeouttimer/TICRATE >= 180
			and player.playerstate == PST_LIVE
				P_KillMobj(player.mo)
				player.mo.flags = $ & ~MF_NOGRAVITY
				player.mo.flags = $|MF_NOCLIP
				player.mo.flags2 = $ & ~MF2_DONTDRAW
				P_InstaThrust(player.mo, player.mo.angle + ANGLE_270, 30*FRACUNIT)
				P_SetObjectMomZ(player.mo, 30*FRACUNIT, false)
				player.mo.state = S_PLAY_FALL
			end
		end
	end
end)

// Peelout Handling and Water Running

addHook("PostThinkFrame", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
			if not P_IsPlayerManiafied(player) continue end
			if not player.powers[pw_underwater]
			and FixedRound(player.speed) >= 50*FRACUNIT
			or player.powers[pw_underwater]
			and FixedRound(player.speed) >= 30*FRACUNIT
			or FixedRound(player.speed) >= player.runspeed
			and player.powers[pw_super]
				if P_IsPlayerOnGround(player)
					P_SpawnSkidDust(player, player.speed/4)
				end
				P_Thrust(player.mo, player.drawangle, FRACUNIT/10)
				if player.powers[pw_sneakers]
					P_Thrust(player.mo, player.drawangle, FRACUNIT/5)
				end
				if player.powers[pw_super]
					P_Thrust(player.mo, player.drawangle, FRACUNIT/5)
				end
				player.powers[pw_strong] = $|STR_SPIKE|STR_WALL
				if player.mo.state == S_PLAY_RUN
				and P_IsPlayerOnGround(player)
				and player.peeloutanim
					player.mo.state = S_PLAY_DASH
				end
				if player.speedeffect
					coolspeedwindlines(player)
					coollookindust(player)
					SpawnGhost(player)
				end
				if player.waterrun
					player.charflags = $|SF_RUNONWATER
				end
			elseif not player.powers[pw_underwater]
			and FixedRound(player.speed) < 50*FRACUNIT
			or player.powers[pw_underwater]
			and FixedRound(player.speed) < 30*FRACUNIT
			or FixedRound(player.speed) <= player.runspeed
			and player.powers[pw_super]
				player.powers[pw_strong] = $ & ~(STR_SPIKE|STR_WALL)
				if player.peeloutanim
				and player.mo.state == S_PLAY_DASH
				and P_IsPlayerOnGround(player)
					player.mo.state = S_PLAY_RUN
				end
				if player.waterrun
					player.charflags = $ & ~SF_RUNONWATER
				end
			end
		end
	end
end)

addHook("PlayerCanDamage", function(player)
	if not P_IsPlayerManiafied(player) return end
	if not player.powers[pw_underwater]
	and not player.powers[pw_super]
	and FixedRound(player.speed) >= 50*FRACUNIT
	or player.powers[pw_underwater]
	and not player.powers[pw_super]
	and FixedRound(player.speed) >= 30*FRACUNIT
		return true
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.stretch
			thicc(player)
		end
	end
end)

--water spash code and sprites re-used from junio sonic, freeslot is from chrispychars

local function CheckSlot(item) // this function deliberately errors when a freeslot does not exist
	if _G[item] == nil // this will error by itself for states and objects
		error() // this forces an error for sprites, which do actually return nil for some reason
	end
end

local function SafeFreeslot(...)
	local item = ...
	if item == nil
		return
	end
	
	if pcall(CheckSlot, item)
		print("\131NOTICE:\128 " .. item .. " was not allocated, as it already exists.")
	else
		freeslot(item)
	end
	
	SafeFreeslot(select(2, ...))
end

SafeFreeslot("SPR_AIDU", "S_KICKDUST")

states[S_KICKDUST] = {
	sprite = SPR_AIDU,
	frame = FF_ANIMATE | FF_PAPERSPRITE,
	var1 = 5,
	var2 = 1,
	tics = 10
}


addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and P_IsPlayerManiafied(player)
		local mo = player.mo
		if player.waterruneffect
			if (player.charflags & SF_RUNONWATER) and leveltime % 3 == 0 and P_IsObjectOnGround(player.mo) and mo.eflags & MFE_TOUCHWATER and player.speed > skins[player.mo.skin].normalspeed
			and not (P_PlayerTouchingSectorSpecial(player, 1, 3))
				for i = -1, 1, 2
					local ang = i * ANG10
					local factor = FixedMul(4*mo.scale, cos(ang))
					local x = P_ReturnThrustX(mo, player.drawangle + ANGLE_180 + ang, 24*mo.scale)
					local y = P_ReturnThrustY(mo, player.drawangle + ANGLE_180 + ang, 24*mo.scale)
					local dust = P_SpawnMobjFromMobj(mo, x, y, 0, MT_THOK)
					dust.scale = 2*$/3
					dust.angle = R_PointToAngle2(dust.x, dust.y, mo.x, mo.y)
					dust.state = S_KICKDUST
					dust.momx = FixedMul(factor, cos(dust.angle - i*ANGLE_90))
					dust.momy = FixedMul(factor, sin(dust.angle - i*ANGLE_90))
				end
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and P_IsPlayerManiafied(player)
	and not player.airwalk
		if not P_IsObjectOnGround(player.mo)
		and (player.mo.state == S_PLAY_WALK
		or player.mo.state == S_PLAY_RUN
		or player.mo.state == S_PLAY_STND
		or player.mo.state == S_PLAY_DASH
		or player.mo.state == S_PLAY_SKID
		or player.mo.state == S_PLAY_SPRING
		or player.mo.state == S_PLAY_FALL
		or (player.mo.state == S_PLAY_ROLL
		and not player.dropdash))
		and not (player.pflags & PF_JUMPED)
		and not player.powers[pw_carry]
		and not P_PlayerInPain(player)
		and player.playerstate == PST_LIVE
			if not (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.momz > 5*FRACUNIT
			or (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.momz < -5*FRACUNIT
				if player.mo.state ~= S_PLAY_SPRING
					player.mo.state = S_PLAY_SPRING
				end
			elseif not (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.momz < -5*FRACUNIT
			or (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.momz > 5*FRACUNIT
				if player.mo.state ~= S_PLAY_FALL
					player.mo.state = S_PLAY_FALL
				end
			else
				if player.mo.state ~= S_PLAY_ROLL
					player.mo.state = S_PLAY_ROLL
				end
			end
		end
	end
end)

addHook("SpinSpecial", function(player)
	if not P_IsPlayerManiafied(player) return end
	if player.spintics > 1 return end
	if player.uncurl == false return end
	if (player.pflags & PF_SPINNING) 
	and player.spintics <= 1
	and not (player.pflags & PF_SPINDOWN)
	and not (player.pflags & PF_STARTDASH)
		player.mo.state = S_PLAY_WALK
		player.pflags = $ & ~PF_SPINNING
		player.pflags = $|PF_SPINDOWN
		return true
	end
end)

// MoonMen

addHook("PlayerMsg", function(player, type, target, msg)
	if type == 2 or type == 1 return end
	local servername = CV_FindVar("servername")
	if string.find(msg, tostring(("Hey " + (servername.string) + ", " + (player.name) + " here!")))
		if player == server 
		or IsPlayerAdmin(player)
			S_ChangeMusic("MNMN", true)
		else
			print((player.name) + " is trying to be vsauce lol")
		end
	end
end)